//
// Moravec ڥ졼ƥ
//

#include <iostream>
#include <fstream>

using namespace std;

#include <unistd.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

#include "Moravec.h"
#include "imagefile.h"

void
usage(char *command)
{
   cerr << "usage: " << command << " "
	<< "[-r ratio] [-n max_corner] [-d min_dist] [-o out.pgm] "
	<< "[-p cornerfile] in.pgm" << endl;
   cerr << "  Input file:  in.pgm" << endl;
   cerr << "  Outputs:     cornerfile, [out.pgm]" << endl;
   cerr << "  Options:" << endl;
   cerr << "       -r ratio        relative ratio to maximum moverac value (0.00001)" << endl;
   cerr << "       -n max_corner   number of corners (200)" << endl;
   cerr << "       -d min_dist     minimum distance between corners (8)" << endl;
   cerr << "       -c cornerfile   coordinates of detected corners (stdout)" << endl;
   cerr << "       -o outimage     output pgm image (none)" << endl;
}

void
output_corners(char *filename, int *u0, int *v0, int N)
{
   ofstream	fout(filename);
   char         buff[30];

   if (fout.bad())
   {
      cerr << "output_corners(): unable to open " << filename << endl;
      return;
   }

   fout << N << endl;
   for (int i = 0; i < N; i++)
   {
      sprintf(buff, "(%8d,%8d)", u0[i], v0[i]);
      fout << buff << endl;
   }

   fout.close();
}

int
main(int argc, char **argv)
{
   int		*imin, *imout;
   char		im_iname[80], im_oname[80], cnr_name[80], buff[30];
   int		width, height;
   double	ratio;
   double	min_d;
   int		l, num, max_c;
   int		*u0, *v0;
   int		opt;

   // ǥեͤΥå
   ratio = Rel_Ratio;
   max_c = Max_Corner;
   min_d = Min_Distance;
   im_iname[0] = im_oname[0] = cnr_name[0] = '\0';

   // ץν
   while ((opt = getopt(argc, argv, "r:n:d:o:c:")) != -1)
   {
      switch (opt)
      {
	case 'r':
	   ratio = atof(optarg);
	   break;
	case 'n':
	   max_c = atoi(optarg);
	   break;
	case 'd':
	   min_d = atoi(optarg);
	   break;
	case 'o':
	   strcpy(im_oname, optarg);
	   break;
	case 'c':
	   strcpy(cnr_name, optarg);
	   break;
      }
   }

   if (optind < argc)
      strcpy(im_iname, argv[optind++]);
   else
   {
      usage(argv[0]);
      exit(1);
   }

   load_pgm_file(&imin, im_iname, &width, &height);

   if (im_oname[0] == '\0')
      l = Moravec(imin, width, height, &u0, &v0, &num,
		  ratio, max_c, min_d);
   else
   {
      imout = new int [width * height];
      l = Moravec(imin, imout, width, height, &u0, &v0, &num,
		  ratio, max_c, min_d);
      save_pgm_file(imout, im_oname, width, height);
   }

   if (cnr_name[0] != '\0')
      output_corners(cnr_name, u0, v0, num);
   else
   {
      cout << num << endl;
      for (int i = 0; i < num; i++)
      {
         sprintf(buff, "(%8d,%8d)", u0[i], v0[i]);
	 cout << buff << endl;
      }
   }
}
